/*	EX2.C 	*/


# include <sys/types.h>
# include <sys/socket.h>
# include <netdb.h>
# include <netinet/in.h>
# include <stdio.h>
/*----------------------------------------*/
# include <unistd.h> 	/* close() */
# include "defns.h"
/*----------------------------------------*/

// type casting in ANSI C:
#define SS struct sockaddr

struct hostent *gethostbyname() ;
void receiver();
void sender();

/*-----------   prototypes ---------------*/
char* inet_ntoa(struct in_addr);
uid_t getuid(void);
int close(int fildes);

Status UDPsend(int s, Message *m, SA dest);
Status UDPreceive(int s, Message *m, SA *origin);

Status DoOperation(Message *msg, Message *reply, int s, SA serverSA);
Status GetRequest(Message *callmsg, int s, SA *clientSA);
Status SendReply(Message *repmsg, int s, SA *clientSA);
/*----------------------------------------*/

int aport;
#define SIZE 1000

/* main for sender and receiver - to send give s message1 and message2
	- to receive give r
	*/
int main(int argc, char **argv)
{
	aport = IPPORT_RESERVED + getuid();

	if(argc <= 1){
		printf("Usage:s(end) ...or r(eceive) ??\n");
		exit();
	}
	if(*argv[1]  == 's')
		{
		if(argc <=2) 
			{
			printf("Usage: s  server_name message1 message2\n");
			exit();
			}
		sender(argv[2], argv[3], argv[4], aport);
		}
	else if(*argv[1]  == 'r')
		{ receiver(aport);
}
	else printf("send machine or receive??\n");

return(0);	
}


/*print a socket address */
void printSA(struct sockaddr_in sa)
{
	printf("sa = %d, %s, %d\n", sa.sin_family,
inet_ntoa(sa.sin_addr), ntohs(sa.sin_port));
}


/* make a socket address for a destination whose machine and port
	are given as arguments */
void makeDestSA(struct sockaddr_in *sa, int port, char *hostname)
{
	struct hostent *host;
	/*char *hostname = "cs4sun";*/
	/*char *hostname = "earth";*/
	/*char *hostname = "venus";
*/

	sa->sin_family = AF_INET;
	if((host = gethostbyname(hostname))== NULL)
		{
		printf("Unknown host name\n");
		exit(-1);
		}
	sa->sin_addr = *(struct in_addr *) (host->h_addr);
	sa->sin_port = htons(port);
}


/* make a socket address using any of the addressses of this computer
for a local socket on any port */
void makeLocalSA(sa)
struct sockaddr_in sa;
{
	sa.sin_family = AF_INET;
	sa.sin_port = htons(0);
	sa.sin_addr.s_addr = htonl(INADDR_ANY);
}


/* make a socket address using any of the addresses of this computer
for a local socket on given port */
void makeReceiverSA(struct sockaddr_in *sa, int port)
{
	sa->sin_family = AF_INET;
	sa->sin_port = htons(port);
	sa-> sin_addr.s_addr = htonl(INADDR_ANY);
}


/*receive two messages via s new socket,
	print out the messages received and close the socket
	bind to  any of the addresses of this computer
	using port given as argument */
void receiver(int port)
{
	char message1[SIZE], message2[SIZE];
	struct sockaddr_in mySocketAddress, aSocketAddress;
	int s,aLength, n;

	if((s = socket(AF_INET, SOCK_DGRAM, 0))<0) 
		{
		perror("socket failed");
		return;
		}

	makeReceiverSA(&mySocketAddress, port);

	if( bind(s, (SS *) &mySocketAddress, sizeof(struct sockaddr_in))!= 0)
		{
		perror("Bind failed\n");
		close(s);
		return;
		}

	printSA(mySocketAddress);

	aLength = sizeof(aSocketAddress);
	aSocketAddress.sin_family = AF_INET;
	if((n = recvfrom(s, message1,  SIZE, 0, (SS *) &aSocketAddress, &aLength))<0)
		perror("error: message 1") ;
	else
		{
		message1[n] = 0;
		printf("Received Message:(%s) length = %d \n",
message1,n);
		}
	if((n = recvfrom(s, message2,  SIZE, 0, (SS *) &aSocketAddress, &aLength))<0) 
		perror("error: message 2");
	else 
		{
		message2[n] = 0;
		printf("Received Message:(%s) length = %d \n",
message2,n);
		}
	close(s);
	return;
}


/*do send after receive ready, open socket
	bind socket to local internet port
		use any of the local computer's addresses
	send two messages with given lengths to machine and  port
	close socket
*/

void sender(char *hostname, char *message1, char *message2, int port)
{
	int s, n;
	struct sockaddr_in mySocketAddress, yourSocketAddress;

	if(( s = socket(AF_INET, SOCK_DGRAM, 0))<0)
		{
		perror("socket failed");
		return;
		}

	makeLocalSA(&mySocketAddress);

	if( bind(s, (SS *) &mySocketAddress, sizeof(struct sockaddr_in))!= 0)
		{
		perror("Bind failed\n");
		close (s);
		return;
		}

	printSA(mySocketAddress);

	makeDestSA(&yourSocketAddress, port, hostname);

	printSA(yourSocketAddress);
	if( (n = sendto(s, message1, strlen(message1), 0, (SS *) &yourSocketAddress, sizeof(struct sockaddr_in))) < 0) 
		perror("Send for message 1 failed\n");
	else 
		printf("sent %d\n",n);
	if( (n = sendto(s, message2, strlen(message2), 0, (SS*) &yourSocketAddress, sizeof(struct sockaddr_in))) < 0)
		perror("Send for message 2 failed\n");
	else 
		printf("sent %d\n",n);
	close(s);
}