/*	EX2CLIENT.C 	*/


# include <sys/types.h>
# include <sys/socket.h>
# include <netdb.h>
# include <netinet/in.h>
# include <stdio.h>

# include <unistd.h> 	/* close() */
# include "ex2defns.h"
# include <string.h>

// type casting in ANSI C:

struct hostent *gethostbyname() ;

void makeLocalSA(SA *);
void makeDestSA(SA *, int , char *);

int aport;

int main(int argc, char **argv)
{
int aport, s;
Status status;
char data[SIZE];
char *server_name;
SA mySocketAddress, yourSocketAddress;
Message *CallMsg=(Message *)malloc(sizeof(Message));
Message *ReplyMsg=(Message *)malloc(sizeof(Message));
aport = IPPORT_RESERVED + getuid();
if(argc < 1)
	{
	printf("\nUsage:server_name ??");
	exit(-1);
	}
if((s = socket(AF_INET, SOCK_DGRAM, 0))<0)
	{
	perror("\nsocket failed");
	exit(-1);
	}
makeLocalSA(&mySocketAddress);
if( bind(s, (SS *) &mySocketAddress, sizeof(SA))!= 0)
	{
	perror("\nBind failed");
	close (s);
	exit(-1);
	}
server_name = argv[1];
makeDestSA(&yourSocketAddress, aport, server_name);
while(1)
	{
	printf("\nEnter a message: ");
	scanf("%s",data);
	strcpy(CallMsg->data, data);
	CallMsg->length = strlen(CallMsg->data);
	status = DoOperation(CallMsg, ReplyMsg, s, yourSocketAddress);
	if (status == BAD)
		{
		printf("\nUnrecoverable error");
		close(s);
		exit(-1);
		}
	if (status == WRONGLENGTH)
		{
		printf("\nBad message length supplied");
		close(s);
		exit(-1);
		}
	if (status == OK)
		{
		printf(ReplyMsg->data);
		printf("\nThank you for using the server.\n");		
		}
	};
close(s);
return(0);	
}

Status DoOperation(Message *callmsg, Message *reply, int s, SA serverSA)
	{
	Status status;
	status = UDPsend(s, callmsg, serverSA);
	if (*callmsg->data == 'q')
		{
		printf("\n\nS E N T   S E R V E R  S H U T D O W N   M E S S A G E\n\n");
		close(s);
		exit(0);
		}
	if (status != OK) return(status);
	status = UDPreceive(s, reply, &serverSA);
	return(status);
	}

/* make a socket address for a destination whose machine and port
	are given as arguments */
void makeDestSA(SA *sa, int port, char *hostname)
{
	struct hostent *host;
	/*char *hostname = "venus";
*/

	sa->sin_family = AF_INET;
	if((host = gethostbyname(hostname))== NULL)
		{
		printf("\nUnknown host name");
		exit(-1);
		}
	sa->sin_addr = *(struct in_addr *) (host->h_addr);
	sa->sin_port = htons(port);
}


/* make a socket address using any of the addressses of this computer
for a local socket on any port */
void makeLocalSA(SA *sa)
{
	sa->sin_family = AF_INET;
	sa->sin_port = htons(0);
	sa->sin_addr.s_addr = htonl(INADDR_ANY);
}




