/* ex2defns.h */
/***********/

#include <stdlib.h>

#define SIZE 1000
#define SS struct sockaddr

typedef struct sockaddr_in SA;

typedef struct
	{
	unsigned int length;
	unsigned char data[SIZE];
	}Message;
	
typedef enum
	{
	OK, 		/* Operation is successful */
	BAD,		/* Unrecoverable error */
	WRONGLENGTH	/* Bad message length supplied */
	}Status;
	
	
/*-----------   prototypes ---------------*/
char* inet_ntoa(struct in_addr);
uid_t getuid(void);
int close(int fildes);

Status UDPsend(int s, Message *m, SA dest);
Status UDPreceive(int s, Message *m, SA *origin);

Status DoOperation(Message *msg, Message *reply, int s, SA serverSA);
Status GetRequest(Message *callmsg, int s, SA *clientSA);
Status SendReply(Message *repmsg, int s, SA clientSA);
/*----------------------------------------*/


Status UDPsend(int s, Message *m, SA dest)
	{
	int n;
	n = sendto(s, m->data, strlen(m->data), 0, (SS *) &dest, sizeof(SA));
	if (n < 0)
		{
		perror("\nSend for message failed");
		return(BAD);
		}
	return(OK);
	}
	
Status UDPreceive(int s, Message *m, SA *origin)
	{
	int n;
	int alength = sizeof(SA);
	n = recvfrom(s, m->data, SIZE, 0, (SS *) origin, &alength);
	if (n < 0)
		{
		perror("\nerror: Can't receive message") ;
		return(BAD);
		}
	return(OK);
	}