/*	EX2SERVER.C 	*/


# include <sys/types.h>
# include <sys/socket.h>
# include <netdb.h>
# include <netinet/in.h>
# include <stdio.h>
/*----------------------------------------*/
# include <unistd.h> 	/* close() */
# include "ex2defns.h"
/*----------------------------------------*/

// type casting in ANSI C:
#define SS struct sockaddr

struct hostent *gethostbyname() ;

void makeLocalSA(SA *);
void makeDestSA(SA *, int , char *);
void makeReceiverSA(SA *, int );

int aport;

int main()
{
	
SA mySocketAddress, aSocketAddress;
int s, aLength;
Status status;
Message *callmsg=(Message *) malloc(sizeof(Message));
aport = IPPORT_RESERVED + getuid();
if((s = socket(AF_INET, SOCK_DGRAM, 0))<0) 
	{
	perror("\nsocket failed");
	exit(-1);
	}
makeReceiverSA(&mySocketAddress, aport);
if(bind(s, (SS *) &mySocketAddress, sizeof(SA))!= 0)
	{
	perror("\nBind failed");
	close(s);
	exit(-1);
	}
aLength = sizeof(aSocketAddress);
aSocketAddress.sin_family = AF_INET;
while(1)
	{
	status = GetRequest(callmsg, s, &aSocketAddress);
	if(strcmp(callmsg->data, "q") == 0)
		{
		close(s);
		exit(0);
		}
	};

close(s);	
return(0);	
}

Status GetRequest(Message *callmsg, int s, SA* clientSA)
	{
	Status status;
	Message *repmsg;
	status = UDPreceive(s, callmsg, clientSA);
	if (*callmsg->data == 'q')
		{
		printf("\n\nS H U T T I N G   D O W N   S E R V E R\n\n");
		close(s);
		exit(0);
		}		
	repmsg = callmsg; 
	status = SendReply(repmsg, s, *clientSA);
	return(status);
	}
	
Status SendReply(Message *repmsg, int s, SA clientSA)
	{
	Status status;
	status = UDPsend(s, repmsg, clientSA);
	return(status);
	}


/* make a socket address using any of the addresses of this computer
for a local socket on given port */
void makeReceiverSA(SA *sa, int port)
{
	sa->sin_family = AF_INET;
	sa->sin_port = htons(port);
	sa->sin_addr.s_addr = htonl(INADDR_ANY);
}

