/* EX3CLIENT.C */
/***************/

# include <sys/types.h>
# include <sys/socket.h>
# include <netdb.h>
# include <netinet/in.h>
# include <stdio.h>

# include <sys/time.h>

# include <unistd.h> 	/* close() */
# include "ex3defns.h"
# include <string.h>

struct hostent *gethostbyname() ;

void makeLocalSA(SA *);
void makeDestSA(SA *, int , char *);

int aport;

int main(int argc, char **argv)
{
int s;
Status status;
SA mySocketAddress, yourSocketAddress;
char *server_name = (char *)malloc(sizeof(char));
RPCMessage *rpca = (RPCMessage *)malloc(sizeof(RPCMessage));
int *op1 = (int *)malloc(sizeof(int));
int *op2 = (int *)malloc(sizeof(int));
char *op = (char *)malloc(sizeof(char));
Message *m=(Message *)malloc(sizeof(Message));
char plus = '+';
char min = '-';
char mul = '*';
char div = '/';
hrtime_t start;
hrtime_t returned;

aport = IPPORT_RESERVED + getuid();
if(argc < 1)
	{
	printf("\nUsage:server_name ??");
	exit(-1);
	}
if((s = socket(AF_INET, SOCK_DGRAM, 0))<0)
	{
	perror("\nsocket failed");
	exit(-1);
	}
makeLocalSA(&mySocketAddress);
if( bind(s, (SS *) &mySocketAddress, sizeof(SA))!= 0)
	{
	perror("\nBind failed");
	close (s);
	exit(-1);
	}
server_name = argv[1];
makeDestSA(&yourSocketAddress, aport, server_name);
while(1)
	{
	printf("\nEnter Operand1: ");
	scanf("%d", op1);
	printf("\nEnter Operand2: ");
	scanf("%d", op2);
	printf("\nEnter Operator: ");
	scanf("%s", op);	
	rpca->msgType = Request;
	rpca->RPCId = 0;
	if (*op == '+') rpca->procedureID = 1;
	if (*op == '-') rpca->procedureID = 2;
	if (*op == '*') rpca->procedureID = 3;
	if (*op == '/') rpca->procedureID = 4;
	if (*op == '%') rpca->procedureID = 5;
	rpca->arg1 = *op1;
	rpca->arg2 = *op2;
	start = gethrtime();
	marshal(rpca, m);
	/*printf("\n\n Client sent data to server. After Marshalling...");
	printf("\nm = %s",m->data);*/
	status = UDPsend(s, m, yourSocketAddress);
	if (*op == '%')
		{ 
		printf("\n\nS E N T   S E R V E R   S H U T D O W N    M E S S A G E\n\n");
		close(s);
		return(0);
		}
	status = UDPreceive(s, m, &mySocketAddress);
	unmarshal(rpca, m);
	returned = gethrtime();
	printf("\n\nServer carried out client's request. After Unmarshalling...");
	printf("\n msgType = %d", rpca->msgType);
	printf("\n RPCId = %d", rpca->RPCId);
	printf("\n procedureID = %d", rpca->procedureID);
	printf("\n arg1 = %d", rpca->arg1);
	printf("\n arg2 = %d", rpca->arg2);
	if (status == BAD)
		{
		printf("\nUnrecoverable error");
		close(s);
		exit(-1);
		}
	if (status == WRONGLENGTH)
		{
		printf("\nBad message length supplied");
		close(s);
		exit(-1);
		}
	if (status == OK)
		{
		printf("\n\nResult of Operation = %d",rpca->arg1);
		printf("\nExecution time: %lld",returned-start);
		printf("\n\nThank you for using the server. ");
		}
	};
close(s);
return(0);	
}


/* make a socket address for a destination whose machine and port
	are given as arguments */
void makeDestSA(SA *sa, int port, char *hostname)
{
	struct hostent *host;
	/*char *hostname = "venus";
*/

	sa->sin_family = AF_INET;
	if((host = gethostbyname(hostname))== NULL)
		{
		printf("\nUnknown host name");
		exit(-1);
		}
	sa->sin_addr = *(struct in_addr *) (host->h_addr);
	sa->sin_port = htons(port);
}


/* make a socket address using any of the addressses of this computer
for a local socket on any port */
void makeLocalSA(SA *sa)
{
	sa->sin_family = AF_INET;
	sa->sin_port = htons(0);
	sa->sin_addr.s_addr = htonl(INADDR_ANY);
}




