
#include <stdlib.h>

#define SIZE 1000
#define SS struct sockaddr

typedef struct sockaddr_in SA;

typedef struct
	{
	unsigned int length;
	unsigned char data[SIZE];
	}Message;
	
typedef enum
	{
	OK, 		/* Operation is successful */
	BAD,		/* Unrecoverable error */
	WRONGLENGTH,	/* Bad message length supplied */
	DIVZERO,	/* Division by zero */
	}Status;
	
typedef struct 
	{
	enum {Request, Reply} msgType;
	unsigned int RPCId;		/*unique identifier*/
	unsigned int procedureID; 	
	int arg1; 			/*argument or result*/
	int arg2; 			/*argument or result*/
	}RPCMessage;	

char* inet_ntoa(struct in_addr);
uid_t getuid(void);
int close(int fildes);

Status UDPsend(int s, Message *m, SA dest);
Status UDPreceive(int s, Message *m, SA *origin);

void marshal(RPCMessage *rm, Message *message);
void unmarshal(RPCMessage *rm, Message *message);

Status UDPsend(int s, Message *m, SA dest)
	{
	int n;
	n = sendto(s, m->data, strlen(m->data), 0, (SS *) &dest, sizeof(SA));
	if (n < 0)
		{
		perror("\nSend for message failed");
		return(BAD);
		}
	return(OK);
	}
	
Status UDPreceive(int s, Message *m, SA *origin)
	{
	int n;
	int alength = sizeof(SA);
	n = recvfrom(s, m->data, SIZE, 0, (SS *) origin, &alength);
	if (n < 0)
		{
		perror("\nerror: Can't receive message") ;
		return(BAD);
		}
	return(OK);
	}

void marshal(RPCMessage *rm, Message *message)
	{
	int n;
	int a[5];
	a[0] = htonl(rm->msgType);
	a[1] = htonl(rm->RPCId);
	a[2] = htonl(rm->procedureID);
	a[3] = htonl(rm->arg1);
	a[4] = htonl(rm->arg2);
	n = sprintf(message->data, "%d,%d,%d,%d,%d",a[0],a[1],a[2],a[3],a[4]);
	message->length = n;
	}

void unmarshal(RPCMessage *rm, Message *message)
	{
	int a[5];
	sscanf(message->data, "%d,%d,%d,%d,%d",&a[0],&a[1],&a[2],&a[3],&a[4]);
	rm->msgType = ntohl(a[0]);
	rm->RPCId = ntohl(a[1]);
	rm->procedureID = ntohl(a[2]);
	rm->arg1 = ntohl(a[3]);
	rm->arg2 = ntohl(a[4]);
	}