/*  EX3SERVER.C  */
/*****************/


# include <sys/types.h>
# include <sys/socket.h>
# include <netdb.h>
# include <netinet/in.h>
# include <stdio.h>
/*----------------------------------------*/
# include <unistd.h> 	/* close() */
# include "ex3defns.h"
/*----------------------------------------*/

// type casting in ANSI C:
#define SS struct sockaddr

struct hostent *gethostbyname() ;

void makeLocalSA(SA *);
void makeDestSA(SA *, int , char *);
void makeReceiverSA(SA *, int );

Status add(int x, int y, int *z);
Status subtract(int x, int y, int *z);
Status mul(int x, int y, int *z);
Status divide(int x, int y, int *z);


int aport;

int main()
{
	
SA mySocketAddress, yourSocketAddress;
int s;
Status status;
int *z = (int *)malloc(sizeof(int));
Message *m=(Message *) malloc(sizeof(Message));
RPCMessage *rpca = (RPCMessage *)malloc(sizeof(RPCMessage));
aport = IPPORT_RESERVED + getuid();
if((s = socket(AF_INET, SOCK_DGRAM, 0))<0) 
	{
	perror("\nsocket failed");
	exit(-1);
	}
makeReceiverSA(&mySocketAddress, aport);
if(bind(s, (SS *) &mySocketAddress, sizeof(SA))!= 0)
	{
	perror("\nBind failed");
	close(s);
	exit(-1);
	}
printf("\nS E R V E R    S T A R T E D\n");
while(1)
	{
	status = UDPreceive(s, m, &yourSocketAddress);
	unmarshal(rpca, m);
	printf("\n\nServer received request from client. After Unmarshalling...");
	printf("\n msgType = %d", rpca->msgType);
	printf("\n RPCId = %d", rpca->RPCId);
	printf("\n procedureID = %d", rpca->procedureID);
	printf("\n arg1 = %d", rpca->arg1);
	printf("\n arg2 = %d", rpca->arg2);
	switch(rpca->procedureID)
		{
		case 1:
			status = add(rpca->arg1, rpca->arg2, z);
			break;
		case 2:
			status = subtract(rpca->arg1, rpca->arg2, z);	
			break;
		case 3:
			status = mul(rpca->arg1, rpca->arg2, z);	
			break;
		case 4:
			status = divide(rpca->arg1, rpca->arg2, z);	
			break;
		case 5: 
			printf("\nS H U T T I N G   D O W N    S E R V E R\n\n");
			close(s);
			return(0);
			break;			
		};
	rpca->msgType = Reply;
	rpca->procedureID = 0;
	rpca->arg2 = 0;
	rpca->arg1= *z;			
	marshal(rpca, m);
	status = UDPsend(s, m, yourSocketAddress);
	};
close(s);	
return(0);	
}

Status add(int x, int y, int *z)
	{
	*z = x+y;
	return OK;
	}
	
Status subtract(int x, int y, int *z)
	{
	*z = x-y;
	return OK;
	}
	
Status mul(int x, int y, int *z)
	{
	*z = x*y;
	return OK;
	}

Status divide(int x, int y, int *z) 
	{
	if (y == 0)
		return DIVZERO;
	else
		{
		*z = x/y;
		return OK;
		}	
	
	}


/* make a socket address using any of the addresses of this computer
for a local socket on given port */
void makeReceiverSA(SA *sa, int port)
{
	sa->sin_family = AF_INET;
	sa->sin_port = htons(port);
	sa->sin_addr.s_addr = htonl(INADDR_ANY);
}

